diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulder.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulder.java
new file mode 100644
index 000000000..48bb52c9a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulder.java
@@ -0,0 +1,104 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2i;
+
+import java.util.Random;
+
+public class WorldFeatureBoulder implements WorldFeatureInterface {
+	final double[][] RADIUS_MAPS = new double[][]{{(double)1.5F, (double)1.5F, (double)1.0F}, {(double)1.0F, (double)1.5F, (double)1.0F}};
+	private final Block<?> boulderBlock;
+	private final Block<?> extraBlock;
+
+	public WorldFeatureBoulder(Block<?> boulderBlock, Block<?> extraBlock) {
+		this.boulderBlock = boulderBlock;
+		this.extraBlock = extraBlock;
+	}
+
+	private Block<?> getBlockAt(Vector2i centerXZ, int x, int z) {
+		return boulderBlock;
+	}
+
+	private void plotBlocks(World world, @NotNull Vector2i centerXZ, TilePos queryPos, int x, int y, int z) {
+		for(int xx = centerXZ.x - x; xx <= centerXZ.x + x; ++xx) {
+			Block<?> block = this.getBlockAt(centerXZ, xx, centerXZ.y + z);
+			world.setBlockType(queryPos.set(xx, y, centerXZ.y + z), block);
+			world.setBlockType(queryPos.set(xx, y, centerXZ.y - z), block);
+		}
+
+		for(int xx = centerXZ.x - z; xx <= centerXZ.x + z; ++xx) {
+			Block<?> block = this.getBlockAt(centerXZ, xx, centerXZ.y + x);
+			world.setBlockType(queryPos.set(xx, y, centerXZ.y + x), block);
+			world.setBlockType(queryPos.set(xx, y, centerXZ.y - x), block);
+		}
+	}
+
+	private void generateRadius(World world, Vector2i centerXZ, TilePos queryPos, double r, int y) {
+		int x = 0;
+		int z = (int)r;
+		double d = (double)3.0F - (double)2.0F * r;
+		this.plotBlocks(world, centerXZ, queryPos, x, y, z);
+
+		for(; z > x; this.plotBlocks(world, centerXZ, queryPos, x, y, z)) {
+			++x;
+			if (d > (double)0.0F) {
+				--z;
+				d = d + (double)(4 * (x - z)) + (double)10.0F;
+			} else {
+				d = d + (double)(4 * x) + (double)6.0F;
+			}
+		}
+	}
+
+	private boolean hasSpace(World world, int xc, int y, int zc) {
+		TilePos queryPos = new TilePos();
+
+		for(queryPos.y = y - 2; queryPos.y < y + 2; ++queryPos.y) {
+			for(queryPos.x = xc - 2; queryPos.x < xc + 2; ++queryPos.x) {
+				for(queryPos.z = zc - 2; queryPos.z < zc + 2; ++queryPos.z) {
+					if (!world.isAirBlock(queryPos) && !world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+						return false;
+					}
+				}
+			}
+		}
+		return true;
+	}
+
+	@Override
+	public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+		TilePos currentPos = new TilePos(tilePos);
+		while(world.isAirBlock(currentPos) && currentPos.y > 1) {
+			currentPos.y--;
+		}
+
+		double[] map = this.RADIUS_MAPS[random.nextInt(2)];
+		if (this.hasSpace(world, currentPos.x, currentPos.y, currentPos.z)) {
+			Vector2i centerXZ = new Vector2i(currentPos.x, currentPos.z);
+			TilePos queryPos = new TilePos();
+
+			for(int i = 0; i < map.length; ++i) {
+				this.generateRadius(world, centerXZ, queryPos, map[i], currentPos.y + i);
+			}
+
+			TilePos circlePos = new TilePos();
+
+			for(circlePos.x = currentPos.x - 2; circlePos.x < currentPos.x + 2; ++circlePos.x) {
+				for(circlePos.z = currentPos.z - 2; circlePos.z < currentPos.z + 2; ++circlePos.z) {
+					for(circlePos.y = currentPos.y - 4; circlePos.y < currentPos.y + 4; ++circlePos.y) {
+						if (world.getBlockType(circlePos) == boulderBlock && random.nextInt(8) == 0) {
+							world.setBlockType(circlePos, extraBlock);
+						}
+					}
+				}
+			}
+		}
+
+		return true;
+	}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderGlowstone.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderGlowstone.java
new file mode 100644
index 000000000..ed8ea7192
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderGlowstone.java
@@ -0,0 +1,110 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFluid;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+import static net.minecraft.core.block.BlockLogicFluid.isAcid;
+
+public class WorldFeatureBoulderGlowstone implements WorldFeatureInterface {
+
+    private final Block<?> stoneBlock;
+    private final Block<?> fireBlock;
+    private final int radius;
+
+    /**
+     * Creates a customizable boulder.
+     *
+     * @param stoneBlock The primary block used to build the boulder.
+     * @param fireBlock  The block to place on top (e.g., Fire). Set to null for no top blocks.
+     * @param radius     The size. 1 is 3x3, 2 is a 5x5, etc.
+     */
+    public WorldFeatureBoulderGlowstone(@NotNull Block<?> stoneBlock, @Nullable Block<?> fireBlock, int radius) {
+        this.stoneBlock = stoneBlock;
+        this.fireBlock = fireBlock;
+        this.radius = Math.max(1, radius);
+    }
+
+    private static final int MAX_DOWN_SCAN = 64;
+
+    @Override
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+        TilePos tilePos = new TilePos(tilePosc.x(), tilePosc.y(), tilePosc.z());
+
+        // Find the ground or the bottom of the acid pool. Cap the search distance.
+        int scanned = 0;
+        while ((world.isAirBlock(tilePos) || isAcid(world, tilePos)) && tilePos.y() - 1 > 0 && scanned < MAX_DOWN_SCAN) {
+            tilePos.down();
+            scanned++;
+        }
+
+        // Must be resting on a Nether surface block
+        if (!world.getBlockType(tilePos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+            return false;
+        }
+
+        // Must be generated inside/under an acid pool
+        TilePos queryPos = new TilePos();
+        if (!isAcid(world, tilePos.up(queryPos))) {
+            return false;
+        }
+
+        int maxExpectedHeight = (this.radius * 2) + 2;
+
+        if (hasSpace(world, tilePos.x(), tilePos.y(), tilePos.z(), maxExpectedHeight)) {
+            TilePos centerPos = new TilePos(tilePos.x(), tilePos.y() + 1, tilePos.z());
+
+            for (int x1 = -this.radius; x1 <= this.radius; x1++) {
+                for (int z1 = -this.radius; z1 <= this.radius; z1++) {
+
+                    int dist = Math.abs(x1) + Math.abs(z1);
+
+                    int height = random.nextInt(2) + Math.max(1, (this.radius * 2 + 1) - dist);
+                    if (height <= 0) continue;
+
+                    // Place the main boulder
+                    for(int y1 = 0; y1 < height; y1++){
+                        centerPos.add(x1, y1, z1, queryPos);
+                        world.setBlockType(queryPos, this.stoneBlock);
+                    }
+
+                    // Place the top-layer
+                    if (this.fireBlock != null) {
+                        centerPos.add(x1, height, z1, queryPos);
+                        if (world.isAirBlock(queryPos) || isAcid(world, queryPos)) {
+                            if(random.nextInt(2) == 0){
+                                world.setBlockType(queryPos, this.fireBlock);
+                            }
+                        }
+                    }
+                }
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    private boolean hasSpace(World world, int xc, int y, int zc, int maxExpectedHeight) {
+        TilePos queryPos = new TilePos();
+
+        for (queryPos.y = y + 1; queryPos.y < y + maxExpectedHeight; queryPos.y++) {
+            queryPos.x = xc;
+            queryPos.z = zc;
+
+            if (!world.isAirBlock(queryPos) && !isAcid(world, queryPos)) {
+                return false;
+            }
+        }
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMagmaBoulder.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderMagma.java
similarity index 57%
rename from game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMagmaBoulder.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderMagma.java
index 6146fcf30..8ce53846e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMagmaBoulder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderMagma.java
@@ -5,46 +5,51 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.joml.Vector2i;
 
 import java.util.Random;
 
-public class WorldFeatureMagmaBoulder extends WorldFeature{
+public class WorldFeatureBoulderMagma implements WorldFeatureInterface {
 
     final double[][] RADIUS_MAPS = {
-            {1.5D, 1.5D, 1D},
-            {1D, 1.5D, 1D},
+            {1.5D, 1.5D, 1.0D},
+            {1.0D, 1.5D, 1.0D},
     };
 
     @Override
-    public boolean place(World world, Random random, int x, int y, int z) {
-        TilePos pos = new TilePos(x, y, z);
-        while(world.isAirBlock(pos) && pos.y - 1 > 0) {pos.down(); }
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+        TilePos pos = new TilePos(tilePos);
+
+        while(world.isAirBlock(pos) && pos.y() - 1 > 0) {
+            pos.down();
+        }
 
         double[] map = RADIUS_MAPS[random.nextInt(2)];
-        if (hasSpace(world, pos.x, pos.y, pos.z)) {
-            Vector2i centerXZ = new Vector2i(pos.x, pos.z);
-            TilePos queryPos = new TilePos(pos.x, pos.y, pos.z);
+        if (hasSpace(world, pos.x(), pos.y(), pos.z())) {
+            Vector2i centerXZ = new Vector2i(pos.x(), pos.z());
+            TilePos queryPos = new TilePos(pos);
 
             for (int i = 0; i < map.length; i++) {
-                generateRadius(world, centerXZ, queryPos, map[i], pos.y + i);
+                generateRadius(world, centerXZ, queryPos, map[i], pos.y() + i);
             }
 
             TilePos circlePos = new TilePos();
-            for (circlePos.x = pos.x() - 2; circlePos.x < pos.x() + 2; circlePos.x++) {
-                for (circlePos.z = pos.z() - 2; circlePos.z < pos.z() + 2; circlePos.z++) {
-                    for (circlePos.y = pos.y() - 4; circlePos.y < pos.y + 4; circlePos.y++) {
-
+            for (int x = pos.x() - 2; x < pos.x() + 2; x++) {
+                for (int z = pos.z() - 2; z < pos.z() + 2; z++) {
+                    for (int y = pos.y() - 4; y < pos.y() + 4; y++) {
+                        circlePos.set(x, y, z);
                         if (!world.isAirBlock(circlePos)) {
-                            if (random.nextInt(8) == 0)
+                            if (random.nextInt(8) == 0) {
                                 world.setBlockType(circlePos, Blocks.COBBLE_BASALT);
+                            }
                         }
                     }
                 }
             }
         }
 
-
         return true;
     }
 
@@ -53,13 +58,11 @@ public class WorldFeatureMagmaBoulder extends WorldFeature{
     }
 
     private void plotBlocks(World world, Vector2i center, TilePos queryPos, int x, int y, int z){
+        plotBlock(world, center, queryPos, z, y, x);
+        plotBlock(world, center, queryPos, x, y, z);
+    }
 
-        for(int xx = center.x - x; xx <= center.x + x; xx++) {
-            Block<?> block = getBlockAt(center, xx, center.y + z);
-            world.setBlockType(queryPos.set(xx, queryPos.y, center.y + z), block);
-            world.setBlockType(queryPos.set(xx, queryPos.y, center.y - z), block);
-        }
-
+    private void plotBlock(World world, Vector2i center, TilePos queryPos, int x, int y, int z) {
         for(int xx = center.x - z; xx <= center.x + z; xx++) {
             Block<?> block = getBlockAt(center, xx, center.y + x);
             world.setBlockType(queryPos.set(xx, y, center.y + x), block);
@@ -77,20 +80,22 @@ public class WorldFeatureMagmaBoulder extends WorldFeature{
             if (d > 0) {
                 z--;
                 d = d + 4 * (x - z) + 10;
-            }  else
+            } else {
                 d = d + 4 * x + 6;
-
+            }
             plotBlocks(world, center, queryPos, x, y, z);
         }
     }
 
     private boolean hasSpace(World world, int xc, int y, int zc){
-        TilePos queryPos =  new TilePos();
-        for (queryPos.y = y - 2; queryPos.y < y + 2; queryPos.y++) {
-            for (queryPos.x = xc - 2; queryPos.x < xc + 2; queryPos.x++) {
-                for (queryPos.z = zc - 2; queryPos.z < zc + 2; queryPos.z++) {
-                    if (!world.isAirBlock(queryPos) && !world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK))
+        TilePos queryPos = new TilePos();
+        for (int py = y - 2; py < y + 2; py++) {
+            for (int px = xc - 2; px < xc + 2; px++) {
+                for (int pz = zc - 2; pz < zc + 2; pz++) {
+                    queryPos.set(px, py, pz);
+                    if (!world.isAirBlock(queryPos) && !world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
                         return false;
+                    }
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
index 8560a7512..476a470e2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
@@ -1,32 +1,65 @@
 package net.minecraft.core.world.generate.feature;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class WorldFeatureFire extends WorldFeature
-{
+public class WorldFeatureFire implements WorldFeatureInterface {
 
-    public WorldFeatureFire()
-    {
+    private final Block<?> overrideFireBlock;
+    private final Block<?> overrideGroundBlock;
+
+    public WorldFeatureFire() {
+        this.overrideFireBlock = null;
+        this.overrideGroundBlock = null;
+    }
+
+    public WorldFeatureFire(Block<?> overrideFireBlock, Block<?> overrideGroundBlock) {
+        this.overrideFireBlock = overrideFireBlock;
+        this.overrideGroundBlock = overrideGroundBlock;
     }
 
     @Override
-	public boolean place(World world, Random random, int x, int y, int z)
-    {
-        for(int i = 0; i < 32; i++)
-        {
-            int x1 = (x + random.nextInt(8)) - random.nextInt(8);
-            int y1 = (y + random.nextInt(4)) - random.nextInt(4);
-            int z1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(x1, y1, z1) && (world.getBlockId(x1, y1 - 1, z1) == Blocks.COBBLE_NETHERRACK.id() || world.getBlockId(x1, y1 - 1, z1) == Blocks.BRIMSAND.id()))
-            {
-                world.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
-                world.setBlock(x1, y1 - 1, z1, Blocks.COBBLE_NETHERRACK.id());
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        TilePos downPos = new TilePos();
+
+        for (int i = 0; i < 32; ++i) {
+            queryPos.set(
+                    tilePos.x() + random.nextInt(8) - random.nextInt(8),
+                    tilePos.y() + random.nextInt(4) - random.nextInt(4),
+                    tilePos.z() + random.nextInt(8) - random.nextInt(8)
+            );
+
+            downPos.set(queryPos).down();
+
+            if (world.isAirBlock(queryPos)) {
+                Block<?> surfaceBlock = world.getBlockType(downPos);
+
+                if (this.overrideFireBlock != null && this.overrideGroundBlock != null) {
+                    if (surfaceBlock.hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+                        world.setBlockTypeNotify(queryPos, this.overrideFireBlock);
+                        world.setBlockTypeNotify(downPos, this.overrideGroundBlock);
+                    }
+                }
+
+                else {
+                    if (surfaceBlock.hasTag(BlockTags.INFINITE_BURN_SULFURIC)) {
+                        world.setBlockTypeNotify(queryPos, Blocks.FIRE_SULFURIC);
+                    }
+                    else if (surfaceBlock.hasTag(BlockTags.INFINITE_BURN)) {
+                        world.setBlockTypeNotify(queryPos, Blocks.FIRE);
+                    }
+                }
             }
         }
 
         return true;
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFloorVent.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFloorVent.java
index e9efe2239..5f12bdf2d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFloorVent.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFloorVent.java
@@ -9,70 +9,73 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class WorldFeatureFloorVent implements WorldFeatureInterface
-{
+public class WorldFeatureFloorVent implements WorldFeatureInterface {
     private final int minRadius;
     private final int radiusMod;
 
-
-    public WorldFeatureFloorVent(int minRadius, int radiusMod)
-    {
+    public WorldFeatureFloorVent(int minRadius, int radiusMod) {
         this.minRadius = minRadius;
         this.radiusMod = radiusMod;
     }
 
-    public WorldFeatureFloorVent()
-    {
+    public WorldFeatureFloorVent() {
         this.minRadius = 1;
         this.radiusMod = 2;
     }
 
-    private boolean isAirOrLiquid(World world, TilePos tilePos){
-        return world.isAirBlock(tilePos) ||
-                world.getBlockType(tilePos).hasTag(BlockTags.IS_LAVA) ||
-                world.getBlockType(tilePos).hasTag(BlockTags.IS_WATER);
-    }
-
     @Override
     public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
-        TilePos pos = (TilePos) tilePos;
-        while(isAirOrLiquid(world, pos) && pos.y - 1 > 0) {pos.down(); }
+        TilePos pos = new TilePos(tilePos.x(), tilePos.y(), tilePos.z());
 
-        int radius = minRadius + random.nextInt(radiusMod);
+        pos.x += random.nextInt(8);
+        pos.z += random.nextInt(8);
 
-        TilePos centerPos = new TilePos(pos.x() + random.nextInt(8), pos.y(), pos.z() + random.nextInt(8));
-        TilePos cursor = new TilePos();
+        while (world.isAirBlock(pos) && pos.y > 0) {
+            pos.down();
+        }
 
-        if(!canPlace(centerPos, world) && !isAirOrLiquid(world, centerPos.up(new TilePos()))){
+        if (pos.y <= 0 || !canPlace(pos, world)) {
             return false;
         }
 
-        for(cursor.x = centerPos.x() - radius; cursor.x <= centerPos.x() + radius; cursor.x++) {
-            for (cursor.z = centerPos.z() - radius; cursor.z <= centerPos.z() + radius; cursor.z++) {
-                int xd = cursor.x() - centerPos.x();
-                int zd = cursor.z() - centerPos.z();
+        if (!world.isAirBlock(new TilePos(pos.x, pos.y + 1, pos.z)) ||
+                !world.isAirBlock(new TilePos(pos.x + 1, pos.y + 1, pos.z)) ||
+                !world.isAirBlock(new TilePos(pos.x - 1, pos.y + 1, pos.z)) ||
+                !world.isAirBlock(new TilePos(pos.x, pos.y + 1, pos.z + 1)) ||
+                !world.isAirBlock(new TilePos(pos.x, pos.y + 1, pos.z - 1))) {
+            return false;
+        }
 
-                float dist = xd * xd + zd * zd;
+        int radius = minRadius + random.nextInt(radiusMod);
+        TilePos cursor = new TilePos();
 
-                for(cursor.y = centerPos.y(); cursor.y > pos.y - 4; cursor.y--) {
+        for (cursor.x = pos.x - radius; cursor.x <= pos.x + radius; cursor.x++) {
+            for (cursor.z = pos.z - radius; cursor.z <= pos.z + radius; cursor.z++) {
+                int xd = cursor.x - pos.x;
+                int zd = cursor.z - pos.z;
+                float distSq = xd * xd + zd * zd;
 
-                    if(cursor.y <= 0)
-                        continue;
+                if (distSq > radius * radius) {
+                    continue;
+                }
 
-                    // Skip placement if cursor hasn't hit ground yet
+                for (cursor.y = pos.y; cursor.y > pos.y - 4; cursor.y--) {
+                    if (cursor.y <= 0) continue;
 
-                    if(dist <= (radius * radius) && canPlace(cursor, world)) {
-                        if(cursor.equals(centerPos)){
+                    if (canPlace(cursor, world)) {
+                        if (cursor.x == pos.x && cursor.y == pos.y && cursor.z == pos.z) {
                             world.setBlockTypeNotify(cursor, Blocks.THERMAL_VENT);
                         } else {
-                            if(random.nextInt(4) != 0) {
+                            if (random.nextInt(4) != 0) {
                                 world.setBlockTypeNotify(cursor, Blocks.BASALT);
-                            } else if(random.nextInt(20) == 0) {
+                            } else if (random.nextInt(20) == 0) {
+                                if (cursor.y == pos.y && world.isAirBlock(new TilePos(cursor.x, cursor.y + 1, cursor.z))) {
                                     world.setBlockTypeNotify(cursor, Blocks.THERMAL_VENT);
+                                } else {
+                                    world.setBlockTypeNotify(cursor, Blocks.BASALT);
+                                }
                             }
-
                         }
-
                     }
                 }
             }
@@ -80,12 +83,13 @@ public class WorldFeatureFloorVent implements WorldFeatureInterface
         return true;
     }
 
-    private boolean canPlace(TilePos cursor, World world) {
-
-        if (isAirOrLiquid(world, cursor)) {
+    private boolean canPlace(TilePos cursor, @NotNull World world) {
+        if (world.isAirBlock(cursor) ||
+            world.getBlockType(cursor).hasTag(BlockTags.IS_LAVA) ||
+            world.getBlockType(cursor).hasTag(BlockTags.IS_WATER)) {
             return false;
         }
 
         return world.getBlockType(cursor).hasTag(BlockTags.NETHER_SURFACE_BLOCK);
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatch.java
index 77eee77a1..96be52cc4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatch.java
@@ -1,34 +1,56 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class WorldFeatureNetherPatch extends WorldFeature
-{
-    private final int blockId;
-    @MethodParametersAnnotation(names = {"blockId"})
-    public WorldFeatureNetherPatch(int blockId)
-    {
-        this.blockId = blockId;
+public class WorldFeatureNetherPatch implements WorldFeatureInterface {
+    protected final Block<?> defaultBlock;
+    protected final int attempts;
+
+    public WorldFeatureNetherPatch(Block<?> defaultBlock, int attempts) {
+        this.defaultBlock = defaultBlock;
+        this.attempts = attempts;
+    }
+
+    public WorldFeatureNetherPatch(Block<?> defaultBlock) {
+        this(defaultBlock, 64);
     }
 
     @Override
-	public boolean place(World world, Random random, int x, int y, int z)
-    {
-        while(world.getBlockId(x, y, z) == 0 && y > 0) { y--; }
-        for(int i = 0; i < 8; i++)
-        {
-            int x1 = (x + random.nextInt(4)) - random.nextInt(4);
-            int y1 = (y + random.nextInt(4)) - random.nextInt(4);
-            int z1 = (z + random.nextInt(4)) - random.nextInt(4);
-            if(world.isAirBlock(x1, y1, z1) && Blocks.blocksList[blockId].canBlockStay(world, x1, y1, z1))
-            {
-                world.setBlock(x1, y1, z1, blockId);
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+        TilePos pos = new TilePos(tilePos);
+
+        while (world.isAirBlock(pos) && pos.y() > 0) {
+            pos.down();
+        }
+
+        TilePos queryPos = new TilePos();
+
+        for (int i = 0; i < this.attempts; i++) {
+            queryPos.set(
+                pos.x() + random.nextInt(4) - random.nextInt(4),
+                pos.y() + random.nextInt(4) - random.nextInt(4),
+                pos.z() + random.nextInt(4) - random.nextInt(4)
+            );
+
+            if (world.isAirBlock(queryPos)) {
+                Block<?> blockToPlace = this.getBlockToPlace(world, queryPos);
+
+                if (blockToPlace != null && blockToPlace.canStay(world, queryPos)) {
+                    world.setBlockType(queryPos, blockToPlace);
+                }
             }
         }
 
         return true;
     }
-}
+
+    protected Block<?> getBlockToPlace(World world, TilePos queryPos) {
+        return this.defaultBlock;
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatchBelow.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatchBelow.java
new file mode 100644
index 000000000..1181b6583
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatchBelow.java
@@ -0,0 +1,59 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeatureNetherPatchBelow implements WorldFeatureInterface {
+	private final int blockId;
+
+	@MethodParametersAnnotation(names = {"blockId"})
+	public WorldFeatureNetherPatchBelow(int blockId) {
+		this.blockId = blockId;
+	}
+
+	@Override
+	public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+		TilePos pos = new TilePos(tilePos);
+
+		while (world.isAirBlock(pos) && pos.y() > 0) {
+			pos.down();
+		}
+
+		TilePos queryPos = new TilePos();
+		TilePos targetPos = new TilePos();
+		TilePos tempPos = new TilePos();
+		Block<?> block = Blocks.blocksList[this.blockId];
+
+		for (int i = 0; i < 8; ++i) {
+			queryPos.set(
+				pos.x() + random.nextInt(4) - random.nextInt(4),
+				pos.y() + random.nextInt(4) - random.nextInt(4),
+				pos.z() + random.nextInt(4) - random.nextInt(4)
+			);
+
+			targetPos.set(queryPos.x(), queryPos.y() - 1, queryPos.z());
+
+			if (world.isAirBlock(queryPos) && world.getBlockType(targetPos) == Blocks.BLOCK_ASH) {
+
+				boolean surroundedByAsh =
+					world.getBlockType(tempPos.set(targetPos).east()) == Blocks.BLOCK_ASH &&
+						world.getBlockType(tempPos.set(targetPos).west()) == Blocks.BLOCK_ASH &&
+						world.getBlockType(tempPos.set(targetPos).south()) == Blocks.BLOCK_ASH &&
+						world.getBlockType(tempPos.set(targetPos).north()) == Blocks.BLOCK_ASH;
+
+				if (surroundedByAsh && block.canStay(world, queryPos)) {
+					world.setBlockType(targetPos, block);
+					world.setBlockType(queryPos, Blocks.AIR);
+				}
+			}
+		}
+
+		return true;
+	}
+}
